'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _Promise = require('babel-runtime/core-js/promise')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
	value: true
});

var _nedb = require('nedb');

var _nedb2 = _interopRequireDefault(_nedb);

function wrapCursor(c) {
	c.__origExec = c.exec;
	c.exec = function () {
		return new _Promise(function (yes, no) {
			c.__origExec(function (err) {
				for (var _len = arguments.length, rest = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
					rest[_key - 1] = arguments[_key];
				}

				return err ? no(makeError(err)) : yes.apply(undefined, rest);
			});
		});
	};

	return c;
}

function makeError(msg) {
	return new Error(msg);
}

var Datastore = (function () {
	function Datastore(opts) {
		_classCallCheck(this, Datastore);

		this.dataStore = new _nedb2['default'](opts);
	}

	_createClass(Datastore, [{
		key: 'loadDatabase',
		value: function loadDatabase() {
			var _this = this;

			return new _Promise(function (yes, no) {
				return _this.dataStore.loadDatabase(function (err) {
					return err ? no(makeError(err)) : yes();
				});
			});
		}
	}, {
		key: 'insert',
		value: function insert(docs) {
			var _this2 = this;

			return new _Promise(function (yes, no) {
				return _this2.dataStore.insert(docs, function (err, newDocs) {
					return err ? no(makeError(err)) : yes(newDocs);
				});
			});
		}
	}, {
		key: 'find',
		value: function find(spec) {
			var _this3 = this;

			var opt = arguments.length <= 1 || arguments[1] === undefined ? undefined : arguments[1];

			var makeCursor = false;
			if (opt === true) {
				makeCursor = true;
				opt = undefined;
			}

			if (makeCursor) return wrapCursor(this.dataStore.find(spec, opt));else return new _Promise(function (yes, no) {
				return _this3.dataStore.find(spec, opt, function (err, docs) {
					return err ? no(makeError(err)) : yes(docs);
				});
			});
		}
	}, {
		key: 'findOne',
		value: function findOne(spec) {
			var _this4 = this;

			var opt = arguments.length <= 1 || arguments[1] === undefined ? undefined : arguments[1];

			var makeCursor = false;
			if (opt === true) {
				makeCursor = true;
				opt = undefined;
			}

			if (makeCursor) return wrapCursor(this.dataStore.findOne(spec));else return new _Promise(function (yes, no) {
				return _this4.dataStore.findOne(spec, function (err, doc) {
					return err ? no(makeError(err)) : yes(doc);
				});
			});
		}
	}, {
		key: 'count',
		value: function count(spec) {
			var _this5 = this;

			return new _Promise(function (yes, no) {
				return _this5.dataStore.count(spec, function (err, count) {
					return err ? no(makeError(err)) : yes(count);
				});
			});
		}

		//
		// @returns { numReplaced, newDoc }
		//
	}, {
		key: 'update',
		value: function update(query, _update) {
			var _this6 = this;

			var options = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

			return new _Promise(function (yes, no) {
				return _this6.dataStore.update(query, _update, options, function (err, numReplaced, newDoc) {
					return err ? no(makeError(err)) : yes({ numReplaced: numReplaced, newDoc: newDoc });
				});
			});
		}
	}, {
		key: 'remove',
		value: function remove(query) {
			var _this7 = this;

			var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

			return new _Promise(function (yes, no) {
				return _this7.dataStore.remove(query, options, function (err, numRemoved) {
					return err ? no(makeError(err)) : yes(numRemoved);
				});
			});
		}
	}, {
		key: 'ensureIndex',
		value: function ensureIndex(spec) {
			var _this8 = this;

			return new _Promise(function (yes, no) {
				return _this8.dataStore.ensureIndex(spec, function (err) {
					return err ? no(makeError(err)) : yes();
				});
			});
		}
	}, {
		key: 'removeIndex',
		value: function removeIndex(fieldName) {
			var _this9 = this;

			return new _Promise(function (yes, no) {
				return _this9.dataStore.removeIndex(fieldName, function (err) {
					return err ? no(makeError(err)) : yes();
				});
			});
		}
	}, {
		key: 'compactDataFile',
		value: function compactDataFile() {
			this.dataStore.persistence.compactDataFile();
		}
	}, {
		key: 'setAutoCompactionInterval',
		value: function setAutoCompactionInterval(interval) {
			this.dataStore.persistence.setAutoCompactionInterval(interval);
		}
	}, {
		key: 'stopAutoCompaction',
		value: function stopAutoCompaction() {
			this.dataStore.persistence.stopAutoCompaction();
		}
	}]);

	return Datastore;
})();

exports['default'] = Datastore;
module.exports = exports['default'];